
![MapmyIndia APIs](https://www.mapmyindia.com/api/img/mapmyindia-api.png)  
    
# Flutter MapmyIndia Nearby Widget    
  
  The MapmyIndia Nearby Widget makes it easy to integrate the functionality to search nearby POIs for selected categories in your Flutter application. The Nearby Search widget provided as a means to enable radially search for Nearby Places on MapmyIndia Maps.
The widget offers the following basic functionalities:
- Ability to search for nearby places directly with MapmyIndia Maps visual interface.
- A single method to initiate nearby search across all categories of places available on MapmyIndia.
- Ability to get information from MapmyIndia Nearby Search widget through a callback.

This can be done by following simple steps.      
  
## Getting Started  
To work with MapmyIndia nearby Widget in flutter add these to your package's pubspec.yaml file:  
~~~yaml  
dependencies:  
  mapmyindia_nearby_plugin: ^0.1.0
~~~  
  
Now in your dart code you need to import this package:  
~~~dart  
import 'package:mapmyindia_nearby_plugin/mapmyindia_nearby_plugin.dart';
~~~  
      
      
     
## Adding MapmyIndia Keys      
       
You **must** provide your keys through the `MapmyIndiaAccountManager` class.([click here](https://github.com/MapmyIndia/flutter-mapmyindia-gl#adding-mapmyindia-keys))
  
## Nearby Widget

Use method `openPlaceAutocomplete` to open Place Autocomplete Widget:
~~~dart
// Platform messages may fail, so we use a try/catch PlatformException.  
try {  
  
 NearbyResult nearbyResult = await openNearbyWidget(); 
} on PlatformException {  
    
}
~~~
 

![Email](https://www.google.com/a/cpanel/mapmyindia.co.in/images/logo.gif?service=google_gsuite)   
  
Email us at [apisupport@mapmyindia.com](mailto:apisupport@mapmyindia.com)  
  
​  
  
![](https://www.mapmyindia.com/api/img/icons/stack-overflow.png)  
  
[Stack  Overflow](https://stackoverflow.com/questions/tagged/mapmyindia-api)  
  
Ask a question under the mapmyindia-api  
  
​  
  
![](https://www.mapmyindia.com/api/img/icons/support.png)  
  
[Support](https://www.mapmyindia.com/api/index.php#f_cont)  
  
Need support? contact us!  
  
​  
  
![](https://www.mapmyindia.com/api/img/icons/blog.png)  
  
[Blog](http://www.mapmyindia.com/blog/)  
  
Read about the latest updates & customer stories  
  
​  
  
​  
  
>  ©  Copyright  2021.  CE  Info  Systems  Pvt.  Ltd.  All  Rights  Reserved.  |  [Terms  &  Conditions](http://www.mapmyindia.com/api/terms-&-conditions).
