part of mapmyindia_nearby_plugin;

const MethodChannel _channel = const MethodChannel('mapmyindia_nearby_plugin');

Future<NearbyResult> openNearbyWidget({NearbyOption? nearbyOption, NearbyUIOption? nearbyUIOption, List<CategoryCode>? categories}) async {
  final Map<String, dynamic> optionsMap = <String, dynamic>{};

  void addIfNonNull(String fieldName, dynamic value) {
    if (value != null) {
      optionsMap[fieldName] = value;
    }
  }

  addIfNonNull('nearbyOption', nearbyOption?.toMap());
  addIfNonNull('nearbyUIOption', nearbyUIOption?.toMap());
  if(categories != null) {
    addIfNonNull('categories', categories.map((e) => e.toMap()).toList());
  }
  final String nearbyResult = await _channel.invokeMethod("openNearbyWidget", optionsMap);
  return NearbyResult.fromMap(json.decode(nearbyResult));
}