part of mapmyindia_nearby_plugin;

class NearbyUIOption {
  final String? backgroundColor;
  final String? refLocationCircleColor;
  final double? circleAlpha;
  final String? paginationContainerViewBackgroundColor;
  final Uint8List? paginationPreviousButtonImage;
  final String? paginationPreviousButtonbackgroundcolor;
  final Uint8List? paginationNextButtonImage;
  final String? paginationNextButtonbackgroundcolor;
  final String? nearbyFilterViewContainerBackgroundColor;
  final double? nearbyFilterCellBorderWidth;
  final String? nearbyFilterCellBorderColor;
  final double? nearbyFilterCellCornerRadius;
  final String? nearbySegmentedViewContainerBackgroundColor;
  final int? segmentedControlSelectedSegmentIndex;
  final String? segmentedControlBackgroundColor;
  final String? segmentedControlBorderColor;
  final double? segmentedControlBorderWidth;
  final String? segmentedControlSelectedSegmentTintColor;
  final String? segmentedControlUnselectedforegroundColor;
  final String? segmentedControlSelectedforegroundColor;
  final String? segmentedControltTextFont;
  final String? tableCellBackgroundColor;
  final String? tableCellSeparatorColor;
  final String? placeNameTextColor;
  final String? placeAddressTextColor;
  final String? distanceTextColor;
  final String? navigationBackgroundColor;
  final String? navigationTitleColor;
  final Uint8List? backButtonImage;
  final Uint8List? refLocationIcon;

  final String? nearbyToolbarColor; // done
  final String? nearbyToolbarTintColor; // done
  final String? categoryBackgroundColor; // done
  final String? categoryTextColor; // done
  final String? categoryIconColor;
  final String? changeLocationButtonTextColor; // done
  final String? locationDetailFormattedAddressTextColor; // done
  final String? locationDetailInfoTextColor; // done
  final String? locationDetailsBackgroundColor; // done
  final String? locationDetailsInfoLabelText; // done
  final Uint8List? nearbyToolbarIcon; // done
  final String? selectedCategoryBackgroundColor; // done
  final String? selectedCategoryTextColor; // done
  final String? selectedCategoryIconColor; // done
  final String? submitButtonColor; // done
  final String? submitButtonText; // done
  final String? useCurrentLocationButtonTextColor; //done
  final String? submitButtonTextColor; //done

// nearbyPresentStyle

  NearbyUIOption(
      {this.paginationPreviousButtonImage,
      this.paginationNextButtonImage,
      this.backButtonImage,
      this.backgroundColor,
      this.refLocationCircleColor,
      this.circleAlpha,
      this.paginationContainerViewBackgroundColor,
      this.paginationPreviousButtonbackgroundcolor,
      this.paginationNextButtonbackgroundcolor,
      this.nearbyFilterViewContainerBackgroundColor,
      this.nearbyFilterCellBorderWidth,
      this.nearbyFilterCellBorderColor,
      this.nearbyFilterCellCornerRadius,
      this.nearbySegmentedViewContainerBackgroundColor,
      this.segmentedControlSelectedSegmentIndex,
      this.segmentedControlBackgroundColor,
      this.segmentedControlBorderColor,
      this.segmentedControlBorderWidth,
      this.segmentedControlSelectedSegmentTintColor,
      this.segmentedControlUnselectedforegroundColor,
      this.segmentedControlSelectedforegroundColor,
      this.segmentedControltTextFont,
      this.tableCellBackgroundColor,
      this.tableCellSeparatorColor,
      this.placeNameTextColor,
      this.placeAddressTextColor,
      this.distanceTextColor,
      this.navigationBackgroundColor,
      this.refLocationIcon,
      this.navigationTitleColor,
      this.nearbyToolbarColor,
      this.nearbyToolbarTintColor,
      this.categoryBackgroundColor,
      this.categoryTextColor,
      this.categoryIconColor,
      this.changeLocationButtonTextColor,
      this.locationDetailFormattedAddressTextColor,
      this.locationDetailInfoTextColor,
      this.locationDetailsBackgroundColor,
      this.locationDetailsInfoLabelText,
      this.nearbyToolbarIcon,
      this.selectedCategoryBackgroundColor,
      this.selectedCategoryTextColor,
      this.selectedCategoryIconColor,
      this.submitButtonColor,
      this.submitButtonText,
      this.useCurrentLocationButtonTextColor,
      this.submitButtonTextColor});

  Map<String, dynamic> toMap() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    void addMapIfNonNull(String fieldName, Uint8List value) {
      if (value != null) {
        optionsMap[fieldName] = <String, dynamic>{
          'image': value,
          'length': value.length
        };
      }
    }

    addIfNonNull('backgroundColor', backgroundColor);
    addIfNonNull('refLocationCircleColor', refLocationCircleColor);
    addIfNonNull('circleAlpha', circleAlpha);
    addIfNonNull('paginationContainerViewBackgroundColor',
        paginationContainerViewBackgroundColor);

    //Only IOS
    if (paginationPreviousButtonImage != null) {
      addMapIfNonNull(
          'paginationPreviousButtonImage', paginationPreviousButtonImage!);
    }
//Only IOS
    if (paginationNextButtonImage != null) {
      addMapIfNonNull('paginationNextButtonImage', paginationNextButtonImage!);
    }
//Only IOS
    if (backButtonImage != null) {
      addMapIfNonNull('backButtonImage', backButtonImage!);
    }
    //Only IOS
    addIfNonNull('paginationNextButtonImage', paginationNextButtonImage);
    addIfNonNull('paginationPreviousButtonbackgroundcolor',
        paginationPreviousButtonbackgroundcolor);
    addIfNonNull('paginationNextButtonbackgroundcolor',
        paginationNextButtonbackgroundcolor);
    addIfNonNull('nearbyFilterViewContainerBackgroundColor',
        nearbyFilterViewContainerBackgroundColor);
    //Only IOS
    addIfNonNull('nearbyFilterCellBorderWidth', nearbyFilterCellBorderWidth);
    //Only IOS
    addIfNonNull('nearbySegmentedViewContainerBackgroundColor',
        nearbySegmentedViewContainerBackgroundColor);
    //Only IOS
    addIfNonNull('segmentedControlSelectedSegmentIndex',
        segmentedControlSelectedSegmentIndex);
    addIfNonNull(
        'segmentedControlBackgroundColor', segmentedControlBackgroundColor);
    //Only IOS
    addIfNonNull('segmentedControlBorderColor', segmentedControlBorderColor);
    //Only IOS
    addIfNonNull('segmentedControlBorderWidth', segmentedControlBorderWidth);
    addIfNonNull('segmentedControlSelectedSegmentTintColor',
        segmentedControlSelectedSegmentTintColor);
    //Only IOS
    addIfNonNull('segmentedControltTextFont', segmentedControltTextFont);
    addIfNonNull('tableCellBackgroundColor', tableCellBackgroundColor);
    addIfNonNull('tableCellSeparatorColor', tableCellSeparatorColor);

    addIfNonNull('placeNameTextColor', placeNameTextColor);
    addIfNonNull('placeAddressTextColor', placeAddressTextColor);
    addIfNonNull('distanceTextColor', distanceTextColor);
    addIfNonNull('navigationBackgroundColor', navigationBackgroundColor);
    //Only IOS
    addIfNonNull('nearbyFilterCellCornerRadius', nearbyFilterCellCornerRadius);
    addIfNonNull('segmentedControlUnselectedforegroundColor',
        segmentedControlUnselectedforegroundColor);
    //Only IOS
    addIfNonNull('segmentedControlSelectedforegroundColor',
        segmentedControlSelectedforegroundColor);
    //Only IOS
    addIfNonNull('backButtonImage', backButtonImage);

    //New Added Props
    addIfNonNull('refLocationIcon', refLocationIcon);
    addIfNonNull('navigationTitleColor', navigationTitleColor);
    addIfNonNull('nearbyToolbarColor', nearbyToolbarColor);
    addIfNonNull('nearbyToolbarTintColor', nearbyToolbarTintColor);
    addIfNonNull('categoryBackgroundColor', categoryBackgroundColor);
    addIfNonNull('categoryTextColor', categoryTextColor);
    addIfNonNull('categoryIconColor', categoryIconColor);
    addIfNonNull('changeLocationButtonTextColor', changeLocationButtonTextColor);
    addIfNonNull('locationDetailFormattedAddressTextColor', locationDetailFormattedAddressTextColor);
    addIfNonNull('locationDetailInfoTextColor', locationDetailInfoTextColor);
    addIfNonNull('locationDetailsBackgroundColor', locationDetailsBackgroundColor);
    addIfNonNull('locationDetailsInfoLabelText', locationDetailsInfoLabelText);
    addIfNonNull('nearbyToolbarIcon', nearbyToolbarIcon);
    addIfNonNull('selectedCategoryBackgroundColor', selectedCategoryBackgroundColor);
    addIfNonNull('selectedCategoryTextColor', selectedCategoryTextColor);
    addIfNonNull('selectedCategoryIconColor', selectedCategoryIconColor);
    addIfNonNull('submitButtonColor', submitButtonColor);
    addIfNonNull('submitButtonText', submitButtonText);
    addIfNonNull('useCurrentLocationButtonTextColor', useCurrentLocationButtonTextColor);
    addIfNonNull('submitButtonTextColor', submitButtonTextColor);
    return optionsMap;
  }
}
